# @(#)$Id: lib.tcl,v 1.3 1994/10/01 07:06:38 schwartz Exp $

proc re_split {re str} {
  set result {}
  set match {}

  if {$str == ""} { return {} }

  while {[regexp -indices $re $str match]} {
    set L [lindex $match 0]
    set R [lindex $match 1]

    # stop if we see a zero length match, since we can't step over it easily.
    if {$R < $L} { 
      break 
    }
    # left is 0..L-1; match is L..R; right is R+1..end

    lappend result [string range $str 0 [incr L -1]]
    lappend result [string range $str [expr "$L+1"] $R]	 # ..to include delim
    set str [string range $str [incr R 1] end]
  }
  lappend result $str
  return $result
}
